% Text Mining with MATLAB 2nd Edition
% www.http://www.textmininglab.net/

% CHAPTER 3: Regular Expressions

clear
disp('Example 3.1 ------------------------------------------------------');
disp('THIS EXAMPLE IS NOT A MATLAB SCRIPT')                          %(3.1)
pause;

disp('Example 3.2 ------------------------------------------------------');
string = "This is SECTION 3.1";                                      %(3.2)
pause;

disp('Example 3.3 ------------------------------------------------------');
match = regexp(string,'.','match')                                   %(3.3)
pause;

disp('Example 3.4 ------------------------------------------------------');
[match,index] = regexp(string,'[aeiouAEIOU]','match','start')        %(3.4)
pause;

disp('Example 3.5 ------------------------------------------------------');
[match,index] = regexp(string,'[0-9]','match','start')               %(3.5)
pause;

disp('Example 3.6 ------------------------------------------------------');
[match,index] = regexp(string,'[^0-9a-zA-Z]','match','start')        %(3.6)
pause;

disp('Example 3.7 ------------------------------------------------------');
match = regexpi(string,'[aeiou]','match')                           %(3.7a)
index = regexpi(string,'[^0-9A-Z]')                                 %(3.7b)
pause;

disp('Example 3.8 ------------------------------------------------------');
match = regexp(string,'\d','match')                                 %(3.8a)
match = regexp(string,'\W','match')                                 %(3.8b)
pause;

disp('Example 3.9 ------------------------------------------------------');
whereisthedot = regexp(string,'\.','start')                          %(3.9)
pause;

disp('Example 3.10 -----------------------------------------------------');
string = "'sample 1','sample a','sample20','sample 321'"            %(3.10)
pause;

disp('Example 3.11 -----------------------------------------------------');
regexp(string,'\w+','match')                                        %(3.11)
pause;

disp('Example 3.12 -----------------------------------------------------');
regexp(string,'\w+\s\w+','match')                                   %(3.12)
pause;

disp('Example 3.13 -----------------------------------------------------');
regexp(string,'\w+\s?\d+','match')                                  %(3.13)
pause;

disp('Example 3.14 -----------------------------------------------------');
regexp(string,"'.+'",'match')                                       %(3.14)
pause;

disp('Example 3.15 -----------------------------------------------------');
regexp(string,"'.+?'",'match')                                      %(3.15)
pause;

disp('Example 3.16 -----------------------------------------------------');
string = "This processor's code is: i-351!"                        %(3.16)
pause;

disp('Example 3.17 -----------------------------------------------------');
regexp(string,'[aeiou][^aeiou\s\W\d]{2}','match')                   %(3.17)
pause;

disp('Example 3.18 -----------------------------------------------------');
regexp(string,'(?:[aeiou][^aeiou\s\W\d]){2}','match')               %(3.18)
pause;

disp('Example 3.19 -----------------------------------------------------');
regexp(string,'(?:is)|[is]','match')                                %(3.19)
pause;

disp('Example 3.20 -----------------------------------------------------');
regexp(string,'[is]|(?:is)','match')                                %(3.20)
pause;

disp('Example 3.21 -----------------------------------------------------');
% sample string for illustrating the use of operators in Table 3.5  %(3.21)
s = "attention on how to match an expression at any section of the chat";
pause;

disp('Example 3.22 -----------------------------------------------------');
regexp(s,'\<at') % the start of a word                             %(3.22a)
regexp(s,'at\>') % the end of a word                               %(3.22b)
regexp(s,'\<at|at\>') % either the start or the end of a word      %(3.22c)
regexp(s,'\<at\>') % both the start and the end of a word          %(3.22d)
regexp(s,'^at') % the start of the string                          %(3.22e)
regexp(s,'at$') % and, the end of the string                       %(3.22f)
pause;

disp('Example 3.23 -----------------------------------------------------');
regexp(s,'at(?=\w)') % followed by an alphanumeric character       %(3.23a)
regexp(s,'at(?!\w)') % not followed by an alphanumeric character   %(3.23b)
regexp(s,'(?<=\w)at') % preceded by an alphanumeric character      %(3.23c)
regexp(s,'(?<!\w)at') % not preceded by an alphanumeric character  %(3.23d)
pause;

disp('Example 3.24 -----------------------------------------------------');
s = "<name>Peter</name><age>44</age><city>Boston</city>";           %(3.24)
pause;

disp('Example 3.25 -----------------------------------------------------');
matches = regexp(s,'<(\w+)>(.*?)</\1>','match')                     %(3.25)
pause;

disp('Example 3.26 -----------------------------------------------------');
tokens = regexp(s,'<(\w+)>(.*?)</\1>','tokens')                     %(3.26)
pause;

disp('Example 3.27 -----------------------------------------------------');
tokens{:}                                                           %(3.27)
pause;

disp('Example 3.28 -----------------------------------------------------');
expression = '<(?<attribute>\w+)>(?<value>.*?)</\k<attribute>>';   %(3.28a)
structure = regexp(s,expression,'names')                           %(3.28b)
pause;

disp('Example 3.29 -----------------------------------------------------');
structure(1)                                                       %(3.29a)
structure(2)                                                       %(3.29b)
structure(3)                                                       %(3.29c)
pause;
